Name:           odroidu3-kernel
Version:        3.8.13.28
Release:        4%{dist}
Summary:        Specific kernel for Odroid U3

License:        GPLv2
URL:            http://builder.mdrjr.net/
# http://builder.mdrjr.net/kernel-3.8/2014.10.30-23.41/odroidu2.tar.xz
# apparently upstream provides a tar.xz once and then updates *without* src
# with the same filename ...
Source0:        odroidu2+src.tar.xz
Source1:        http://builder.mdrjr.net/kernel-3.8/2014-12-03_18-36-33-8/odroidu2.tar.xz
Source2:        http://builder.mdrjr.net/tools/firmware.tar.xz

Group:          System Environment/Kernel
Provides:       kernel = %{version}-%{release}
Requires:       dracut, uboot-tools

%description
Specific kernel for Odroid U3
The kernel package contains the Linux kernel (vmlinuz), the core of any
Linux operating system.  The kernel handles the basic functions
of the operating system: memory allocation, process allocation, device
input and output, etc.


%package devel
Group:          System Environment/Kernel
Summary:        Development package for building kernel modules to match the kernel
Provides:       kernel-devel = %{version}-%{release}

%description devel
This package provides kernel headers and makefiles sufficient to build modules
against the kernel package.


%package firmware
Group:          Development/System
Summary:        Firmware files used by the Linux kernel
Provides:       kernel-firmware = %{version}-%{release}

%description firmware
Kernel-firmware includes firmware files required for some devices to
operate.


%prep
%setup -q -c
rm -rf lib boot
mkdir -p lib/firmware
%setup -q -D -T -n %{name}-%{version}/lib/firmware -a2
%setup -q -D -T -a1

%build
mv boot/zImage boot/zImage-%{version}-%{release}
mv boot/config-%{version} boot/config-%{version}-%{release}
mv lib/modules/%{version} lib/modules/%{version}-%{release}
rm lib/modules/%{version}-%{release}/build
rm lib/modules/%{version}-%{release}/source
mkdir usr/src/kernels
mv usr/src/linux-%{version} usr/src/kernels/%{version}-%{release}
ln -s usr/src/kernels/%{version}-%{release} lib/modules/%{version}-%{release}/build
cp lib/firmware/s5p-mfc/* lib/firmware

%install
mkdir -p %{buildroot}
cp -Rp boot lib usr %{buildroot}


%files
%defattr(-,root,root,-)
/lib/modules/%{version}-%{release}/*
/boot/config-%{version}-%{release}
%attr(0755,root,root) /boot/zImage-%{version}-%{release}

%post
cp -a /boot/zImage-%{version}-%{release} /boot/zImage
rm -f /lib/modules/%{version}
ln -s /lib/modules/%{version}-%{release} /lib/modules/%{version}
dracut /boot/initrd-%{version}-%{release} %{version}
mkimage -A arm -O linux -T ramdisk -C none -a 0 -e 0 \
	-n "uInitrd %{version}-%{release}" \
	-d /boot/initrd-%{version}-%{release} \
	/boot/uInitrd-%{version}-%{release}
cp -a /boot/uInitrd-%{version}-%{release} /boot/uInitrd

%preun
rm -f /boot/initrd-%{version}-%{release}
rm -f /boot/uInitrd-%{version}-%{release}
rm -f /lib/modules/%{version}
if [ "$(ls -1 /lib/modules/%{version}-*|wc)" != "1" ] ; then 
    ln -s $(ls -1 /lib/modules/%{version}-* | grep -v /lib/modules/%{version}-%{release} |tail -1) /lib/modules/%{version}
fi

%postun
cp $(ls -1 /boot/uInitrd-*-*|tail -1) /boot/uInitrd
cp $(ls -1 /boot/zImage-*-*|tail -1) /boot/zImage


%files devel
%defattr(-,root,root)
/usr/src/kernels/%{version}-%{release}


%files firmware
%defattr(-,root,root)
/lib/firmware/*

